XIncludeFile "GL.pbi"

;int attrListDbl[] = { GLX_RGBA, GLX_DOUBLEBUFFER, GLX_RED_SIZE, 4, GLX_GREEN_SIZE, 4, GLX_BLUE_SIZE, 4, GLX_DEPTH_SIZE, 16, None };

; WindowHandle,Display,DeviceContext,RenderContext
Global WH.l,DPY.l,DC.l,RC.l



CompilerIf #PB_Compiler_OS = #PB_OS_Linux
;#############
;# LINUX X86 #
;#############
Procedure.l OpenGLWindow(id.l, x.l,y.l,w.l,h.l, title.s, flags.l)
  Dim attr.l(10)
  attr(0) = GLX_RGBA       : attr(1) = GLX_DOUBLEBUFFER
  attr(2) = GLX_RED_SIZE   : attr(3) = 8
  attr(4) = GLX_GREEN_SIZE : attr(5) = 8
  attr(6) = GLX_BLUE_SIZE  : attr(7) = 8
  attr(8) = GLX_DEPTH_SIZE : attr(9) = 16
  attr(10) = 0
   vi = glXChooseVisual(GLWin.dpy, GLWin.screen, attr())
  ProcedureReturn 0
EndProcedure  
Procedure CloseGLWindow()
  If DPY
    If RC
      glXMakeCurrent(DPY, 0,0)
      glXDestroyContext(DPY, RC)
      RC=0
    EndIf
  EndIf
EndProcedure
          
Procedure SwapBuffers()
  If DPY
    glXSwapBuffers(DPY,WH)
  EndIf
EndProcedure

CompilerElse
;###############
;# WINDOWS X86 #
;###############
Procedure.l OpenGLWindow(id.l, x.l,y.l,w.l,h.l, title.s, flags.l)
  Protected pfd.PIXELFORMATDESCRIPTOR
  Protected pf.l
  WH = OpenWindow(id, x,y,w,h,title,flags)
  
  If id=#PB_Any
    id=WH
    WH=WindowID(id)
  EndIf
  
  DC = GetDC_(WH)
  pfd\nSize        = SizeOf(PIXELFORMATDESCRIPTOR)
  pfd\nVersion     = 1
  pfd\dwFlags      = #PFD_SUPPORT_OPENGL | #PFD_DOUBLEBUFFER | #PFD_DRAW_TO_WINDOW
  pfd\dwLayerMask  = #PFD_MAIN_PLANE
  pfd\iPixelType   = #PFD_TYPE_RGBA
  pfd\cColorBits   = 16
  pfd\cDepthBits   = 16 
  pf = ChoosePixelFormat_(DC,pfd)
  SetPixelFormat_(DC, pf, pfd)
  RC = wglCreateContext_(DC)
  wglMakeCurrent_(DC,RC)
  
  ProcedureReturn WH
EndProcedure

Procedure CloseGLWindow()
  If RC
    wglMakeCurrent_(0,0)
    wglDeleteContext_(RC)
    RC=0
  EndIf
  If DC
    ReleaseDC_(WH,DC)
    DC=0
  EndIf
EndProcedure

Procedure SwapBuffers()
  SwapBuffers_(DC)
EndProcedure

CompilerEndIf
; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 66
; FirstLine = 29
; Folding = --
; EnableXP